# Commandant is a framework for building command-oriented tools.
# Copyright (C) 2009 Jamshed Kakar.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

"""Infrastructure extends C{bzrlib.commands.Command} to support executables."""

import os

from bzrlib.commands import Command


class ExecutableCommand(Command):
    """Specialized command runs an executable program."""

    path = None

    def run_argv_aliases(self, argv, alias_argv=None):
        """
        Disable proper handling of argv and aliases so that arguments can be
        passed directly to the executable.
        """
        self.run(argv)

    def run(self, argv):
        """
        Run the executable, passing whatever arguments were passed to the
        command.
        """
        if argv:
            os.system("%s %s" % (self.path, " ".join(argv)))
        else:
            os.system(self.path)
